IMDB Graph 
===========

Goals
-----

The purpose of this assignment is to learn to

1. Build graphs using BRIDGES 
2. Use the IMDB Actor-Movie pairs dataset to build a graph
3. Style the graph (nodes, links) of two specific actors and the movies they are part of.

You will generate a visualization that looks like [that](http://bridges-cs.herokuapp.com/assignments/3/bridges_workshop)!

Programming part
----------------

### Task


### Getting Started

1. Open your scaffolded code.
2. Plug in your credentials.
3. Review the  Graph tutorial [here](http://bridgesuncc.github.io/tutorials/Graph.html)
4. Review the ActorMovieIMDB class in BRIDGES
5. The data is retrieved and stored in a list (of ActorMovieIMDB objects). 
Iterate through the list and add vertices for actors and movies. Note: onlyadd the nodes if they are not already in the graph.
6. Compile, run, and visualize and you should see a large graph
7. Style the graph. Look for the two actors 'Cate_Blanchett' and 'Kevin_Bacon_(I)'; for these actors, set their node colors to something unique and their linkes to the movies a different color (refer to the graph tutorial for how to change visual attributes)
8. Compile, run, and visualize and you should see a large graph

### Help

[BRIDGES Graph Tutorial](http://bridgesuncc.github.io/tutorials/Graph.html)

#### for Java

[GraphAdjListSimple documentation](http://bridgesuncc.github.io/doc/java-api/current/html/classbridges_1_1base_1_1_graph_adj_list_simple.html)

[ElementVisualizer documentation](http://bridgesuncc.github.io/doc/java-api/current/html/classbridges_1_1base_1_1_element_visualizer.html)

[LinkVisualizer documentation](http://bridgesuncc.github.io/doc/java-api/current/html/classbridges_1_1base_1_1_link_visualizer.html)

[ActorMovieIMDB documentation](http://bridgesuncc.github.io/doc/java-api/current/html/classbridges_1_1data__src__dependent_1_1_actor_movie_i_m_d_b.html)

#### for C++


[GraphAdjList documentation](http://bridgesuncc.github.io/doc/cxx-api/current/html/classbridges_1_1_graph_adj_list.html)

[ElementVisualizer documentation](http://bridgesuncc.github.io/doc/cxx-api/current/html/classbridges_1_1_element_visualizer.html)

[LinkVisualizer documentation](http://bridgesuncc.github.io/doc/cxx-api/current/html/classbridges_1_1_link_visualizer.html)

[ActorMovieIMDB documentation](http://bridgesuncc.github.io/doc/cxx-api/current/html/classbridges_1_1_actor_movie_i_m_d_b.html)

#### for Python

[GraphAdjList documentation](http://bridgesuncc.github.io/doc/python-api/current/html/classbridges_1_1graph__adj__list_1_1_graph_adj_list.html)

[ElementVisualizer documentation](http://bridgesuncc.github.io/doc/python-api/current/html/classbridges_1_1element__visualizer_1_1_element_visualizer.html)

[LinkVisualizer documentation](http://bridgesuncc.github.io/doc/python-api/current/html/classbridges_1_1link__visualizer_1_1_link_visualizer.html)
